/*******************************************************************************************************************
Adopt, Discover and Improve

Dmitri V. Korotkevitch 
Sql Saturday #74 
(Jacksonville, FL. April 30, 2011)

Indexes - tuning
*******************************************************************************************************************/


create nonclustered index IDX_Orders_OrderNum
on Delivery.Orders(OrderNum)
go




CREATE NONCLUSTERED INDEX IDX_Orders_DriverId_OrderDate
ON [Delivery].[Orders] ([DriverId],[OrderDate] desc)
INCLUDE ([OrderStatusId])
GO

create nonclustered index Idx_Addresses_CustomerId
on Delivery.Addresses(CustomerId)


create nonclustered index Idx_Customers_RegionID
on Delivery.Customers(RegionId)
include(Name)
go

CREATE NONCLUSTERED INDEX IDX_Orders_CustomerId
ON [Delivery].[Orders] (CustomerId)
INCLUDE (Amount)
GO



-- Indexed view

create view dbo.vOrderStatusCount(OrderStatusId, Name, StatusCnt)
with schemabinding
as
	select o.OrderStatusId, os.Name, COUNT_BIG(*) 
	from Delivery.Orders o join Delivery.OrderStatuses os on
		o.OrderStatusId = os.OrderStatusId 
	group by o.OrderStatusId, os.Name
go

create unique clustered index IDX_vOrderStatusCount_OrderStatusId
on dbo.vOrderStatusCount(OrderStatusId)
go



-- Changes in indexes for paging

drop INDEX IDX_Orders_CustomerId
ON [Delivery].[Orders]
go

CREATE NONCLUSTERED INDEX IDX_Orders_CustomerId
ON [Delivery].[Orders] (CustomerId)
INCLUDE (Amount,OrderDate,OrderStatusId)
GO
